def field_producer(name)
	self
end

def field_caption(name)
	self.class.field_caption[name]
end

def field_producer(name)
	if @field_ref.key?(name)
		@field_ref[name][0]
	else
		self
	end
end

def field_caption(name)
	prod = field_producer(name)
	prod.class.field_caption[name]
end

def field_name_caption_each
	self.class.field_name.each do |name|
		yield(name, field_caption(name))
	end
end

def field_name_caption_each
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			ref_name_list.each do |ref_name|
				yield(ref_name, field_caption(ref_name))
			end
		else
			yield(name, field_caption(name))
		end
	end
end

def field_name_value_each(item)
	self.class.field_name.each do |name|
		yield(name, item[name])
	end
end

def field_name_value_each(item)
	self.class.field_name.each do |name|
		if @field_ref.key?(name)
			prod, *ref_name_list = @field_ref[name]
			ref_item = prod.fetch_hash(item[name])
			ref_name_list.each do |ref_name|
				yield(ref_name, ref_item[ref_name])
			end
		else
			yield(name, item[name])
		end
	end
end

