require 'list'
require 'date'
class Todo < List
  class Item < List::Item
    self.field_name = [:date, :subject, :time_beg, :time_end, :sended]
  end
  self.dir = 'todo_db'
  self.item_class = Item
  def fetch_hash_for_date(range)
    tmp = Hash.new{|hash, key| hash[key] = []}
    today = Date.today
    @item.each{|item|
      date = today
      field = item.field_by_name(:date)
      if field
        begin
          date = Date.parse(field)
          unless range === date
            date = nil
          end
        rescue
          date = today
        end
      end
      tmp[date].push item.to_hash if date
    }
    range.each do |date|
      tmp[date].push [] unless tmp[date]
    end
    ret = []
    mon = nil
    pre = nil
    tmp.keys.sort.each do |date|
      curr = [date, tmp[date]]
      mon_beg = ! mon || mon != date.month
      curr.push mon_beg, false
      mon_beg and pre and pre[3] = true
      pre = curr
      mon = date.month
      ret.push curr
    end
    pre and pre[3] = true
    ret
  end
end
