require 'todo'
require 'listpd'
class TodoProducer < ListProducer
  set_erb('todo.erb')
  self.field_name = Todo::Item.field_name
  self.field_caption = {
    :date => "t",
    :subject => "薼",
    :time_beg => "Jn",
    :time_end => "I",
    :sended => "sended",
  }
  self.caption = ''
  def self.field_width
    @field_width
  end
  @field_width = {
    :date => 80,
    :subject => 180,
    :time_beg => 60,
    :time_end => 60,
    :sended => 60,
  }
  def initialize(session, todo)
    super(session, todo)
    @date = Date.today
  end
  def remove(key)
    super
    check = @session.application.check
    check.fetch_hash_all{|i|
      if i[:todo] == key
        check.remove(i[:key])
      end
    }
  end
  def do_browse(context, params)
    super
    date, = params['date']
    @date = Date.parse(date) if date rescue Date.today
  end
  def do_edit(context, params)
    case @mode
    when :edit
      if params.key?('copy')
        do_add(context, params)
        @mode = :browse
        return
      end
    end
    super
  end
end
